/*************************************************
* CFB Mode Header File                           *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_CFB_H__
#define OPENCL_CFB_H__

#include <opencl/key_filt.h>
#include <opencl/modebase.h>

namespace OpenCL {

/*************************************************
* CFB Encryption                                 *
*************************************************/
class CFB_Encryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      CFB_Encryption(BlockCipher*, const BlockCipher_Key&,
                     const BlockCipherModeIV&, u32bit = 0);
   private:
      const u32bit FEEDBACKSIZE;
      void feedback();
   };

/*************************************************
* CFB Decryption                                 *
*************************************************/
class CFB_Decryption : public BlockCipherMode
   {
   public:
      void write(const byte[], u32bit);
      CFB_Decryption(BlockCipher*, const BlockCipher_Key&,
                     const BlockCipherModeIV&, u32bit = 0);
   private:
      const u32bit FEEDBACKSIZE;
      void feedback();
   };

}

#endif
