/*************************************************
* Encoder Header File                            *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#ifndef OPENCL_ENCODER_H__
#define OPENCL_ENCODER_H__

#include <opencl/hex.h>
#include <opencl/base64.h>
#include <opencl/filters.h>

#if defined(__GNUG__)
#warning encoder.h (and the contents thereof) are deprecated as of 0.8.3
#endif

namespace OpenCL {

class Base64
   {
   public:
      static const u32bit INPUTSIZE = 3, OUTPUTSIZE = 4, CODE_BITS = 6;
      static void encode(const byte[INPUTSIZE], byte[OUTPUTSIZE]);
      static void decode(const byte[OUTPUTSIZE], byte[INPUTSIZE]);
      static bool is_valid(byte in) { return Base64_Decoder::is_valid(in); }
   };

class Hex
   {
   public:
      static const u32bit INPUTSIZE = 1, OUTPUTSIZE = 2, CODE_BITS = 4;
      static void encode(byte in, byte out[OUTPUTSIZE]) { encode(&in, out); }
      static void decode(const byte in[OUTPUTSIZE], byte& out)
         { decode(in, &out); }

      static void encode(const byte[INPUTSIZE], byte[OUTPUTSIZE]);
      static void decode(const byte[OUTPUTSIZE], byte[INPUTSIZE]);
      static bool is_valid(byte in) { return Hex_Decoder::is_valid(in); }
   };

}

#endif
