/*************************************************
* Encoder Source File                            *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/encoder.h>

namespace OpenCL {

/*************************************************
* Base64 Encoder                                 *
*************************************************/
void Base64::encode(const byte in[INPUTSIZE], byte out[OUTPUTSIZE])
   {
   Base64_Encoder::encode(in, out);
   }

/*************************************************
* Base64 Decoder                                 *
*************************************************/
void Base64::decode(const byte in[OUTPUTSIZE], byte out[INPUTSIZE])
   {
   Base64_Decoder::decode(in, out);
   }

/*************************************************
* Hex Encoder                                    *
*************************************************/
void Hex::encode(const byte in[INPUTSIZE], byte out[OUTPUTSIZE])
   {
   Hex_Encoder::encode(in[0], out);
   }

/*************************************************
* Hex Decoder                                    *
*************************************************/
void Hex::decode(const byte in[OUTPUTSIZE], byte out[INPUTSIZE])
   {
   out[0] = Hex_Decoder::decode(in);
   }

}
