/*************************************************
* KDF1 Source File                               *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/kdf1.h>

namespace OpenCL {

/*************************************************
* KDF1 Key Derivation Mechanism                  *
*************************************************/
SymmetricKey KDF1::derive(const byte in[], u32bit length, u32bit) const
   {
   hash->update(in, length);
   hash->update(P, P.size());
   return SymmetricKey(hash->final());
   }

/*************************************************
* KDF1 Key Derivation Mechanism                  *
*************************************************/
KDF1::KDF1(HashFunction* h, const std::string& Pstr)
   {
   hash = h;
   P.copy((const byte*)Pstr.data(), Pstr.size());
   }

}
