/*************************************************
* MGF1 Source File                               *
* (C) 1999-2002 The OpenCL Project               *
*************************************************/

#include <opencl/mgf1.h>

namespace OpenCL {

/*************************************************
* MGF1 Mask Generation Function                  *
*************************************************/
void MGF1::mask(const byte in[], u32bit in_len, byte out[],
                u32bit out_len) const
   {
   SecureBuffer<byte, 4> counter;
   SecureVector<byte> buffer(hash->OUTPUT_LENGTH);
   while(out_len)
      {
      hash->update(in, in_len);
      hash->update(counter, 4);
      hash->final(buffer);

      u32bit xored = std::min(buffer.size(), out_len);
      xor_buf(out, buffer, xored);
      out += xored;
      out_len -= xored;

      for(s32bit j = 3; j >= 0; j--)
         if(++counter[j])
            break;
      }
   }

}
